
const LOKIWRAPPER_CONTRACTID = '@loki.com/locationservice;1';

const LOKIWRAPPER_CID = Components.ID('{F443406C-961D-4ecc-BF39-C0E9943C72AF}');
const LOKIWRAPPER_IID = Components.interfaces.iLocationservice;
var LokiSky_timer=null;

function Lokiwrapper() 
 { 

 }

Lokiwrapper.prototype = 
 {
     getPullModel: function(toolbar,obj,type) 
     {
       var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
       var chromeWindow = wm.getMostRecentWindow("navigator:browser");

      //chromeWindow.alert(chromeWindow.content.document.location);
      var str;
      switch (type)
       {
         case 0:
           {
             str="n/a"
             break;
           }  
         case 1:
           {
             str="City, State, Country, Zip Code"
             break;
           }  
         case 2:
           {
             str="House_num,Street,City, State, Country, Zip Code"
             break;
           }  
         case 0xF0:
           {
             str="Latitude, Longitude"
             break;
           }  
         case 0xF1:
           {
             str="Latitude, Longitude,City, State, Country, Zip Code, Street"

             break;
           }  
         case 0xF2:
           {
             str="Latitude, Longitude,House_num,Street,City, State, Country, Zip Code"
             break;
           }  

       }

       var url="";
       url=chromeWindow.content.document.location.toString();//toolbar.value;
       if (url=="about:blank") return 1;

       var txt1;
       var txt=url.match (/:\/\/(\w|\.)+\//);                               
       if (txt==null)
       {
        txt=url.match (/:\/\/(\w|\.|\/)+/);   
        txt1=txt[0].substring(3);                
       }
       else
       {
        txt1=txt[0].substring(3,txt[0].length-1);
       }   
       if (txt[0]!=null)
        {
          //var txt1=txt[0].substring(3,txt[0].length-1);                                                           
          var i=txt1.search(/www\./);
          if(i!=-1)
          {
            txt1=txt1.substring(i+4);   
          }     
          var res;
          if (txt1!=null)
          {
            url=txt1;
          }
        }
 

      var param = new Object()
      param.url=url;//this.obj.location;
      param.loc=str;
      param.res=0;

      var Loki = Components.classes["@loki.com/locationservicenative;1"].getService(); 
      Loki = Loki.QueryInterface(Components.interfaces.iLocationservicenative);

      var l=Loki.loadOption("location_request","options");  
      if (l==0) return 1;
      if (l==2) return 0;


      var opt=0;
     // chromeWindow.alert(param.url);
      var accs=Loki.loadAdr(param.url);
      if (accs==null)
       {
        opt=1;
       }
      else
       {
         if (accs=="block") {return 0;} 
      /*
         var d=Loki.loadOption("remember_check","dialog");  
         if (d=="on")
           {
             if (accs=="block") {return 0;} 
           }
         else
           {
           // this.obj.alert("off");
            opt=1;       
           }               
        */
       }
      if(opt==1)
      {
       chromeWindow.openDialog("chrome://loki/content/lokipull/pull_dialog.xul",null,"chrome,centerscreen,modal",param);//Loki Location Request
       var d1=Loki.loadOption("remember_check","dialog");  

       if (d1=="on")
         {

           Loki.refreshConfig();
           Loki.saveOption("remember_check","dialog","off");
           if (param.res==0) { Loki.saveAdr(param.url,"block");}
           else {Loki.saveAdr(param.url,"allow");}
           Loki.saveConfig();
         }
       if (param.res==0) return 0;
  
      } 

        return 1;
     },
    QueryInterface: function(iid) {
       var Loki = Components.classes["@loki.com/locationservicenative;1"].getService();
        if (!iid.equals(Components.interfaces.nsISupports) &&
            !iid.equals(LOKIWRAPPER_IID))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        return this;
    }
};

var LokiwrapperModule = 
{
  registerSelf: function(compMgr, fileSpec, location, type) {
        compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);

        compMgr.registerFactoryLocation(LOKIWRAPPER_CID,
                                        "Lokiwrapper",
                                        LOKIWRAPPER_CONTRACTID,
                                        fileSpec,
                                        location,
                                        type);
    },
    getClassObject: function(compMgr, cid, iid) {
        if (!cid.equals(LOKIWRAPPER_CID))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        if (!iid.equals(Components.interfaces.nsIFactory))
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
        return LokiwrapperFactory;    
    },
    canUnload: function(compMgr) { return true; }
};
var LokiwrapperFactory = {
    createInstance: function(outer, iid) {
        if (outer != null)
            throw Components.results.NS_ERROR_NO_AGGREGATION;
        if (!iid.equals(LOKIWRAPPER_IID) &&
            !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_INVALID_ARG;
        return new Lokiwrapper();
    } 
};
function NSGetModule(comMgr, fileSpec) { return LokiwrapperModule; } 
